Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs	(revision 9433)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs	(revision 9434)
@@ -37,6 +37,6 @@
     }
 
-    private IHiveDtoDao dao {
-      get { return ServiceLocator.Instance.HiveDtoDao; }
+    private IHiveDao dao {
+      get { return ServiceLocator.Instance.HiveDao; }
     }
 
Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveOperationContext.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveOperationContext.cs	(revision 9433)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveOperationContext.cs	(revision 9434)
@@ -22,15 +22,13 @@
 using System;
 using System.Collections.ObjectModel;
-using System.Diagnostics;
-using System.IO;
 using System.ServiceModel;
 using System.ServiceModel.Channels;
 using System.ServiceModel.Description;
 using System.ServiceModel.Dispatcher;
-using System.Text;
 using HeuristicLab.Services.Hive.DataAccess;
 
 namespace HeuristicLab.Services.Hive {
   public class HiveOperationContext : IExtension<OperationContext> {
+
     public static HiveOperationContext Current {
       get {
@@ -42,9 +40,5 @@
     public HiveDataContext DataContext {
       get {
-        if (dataContext == null) {
-          dataContext = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString);
-          //dataContext.Log = new DebugWriter();
-        }
-        return dataContext;
+        return dataContext ?? (dataContext = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString));
       }
     }
@@ -67,5 +61,5 @@
     }
 
-    public void BeforeSendReply(ref System.ServiceModel.Channels.Message reply, object correlationState) {
+    public void BeforeSendReply(ref Message reply, object correlationState) {
       OperationContext.Current.Extensions.Remove(HiveOperationContext.Current);
     }
@@ -88,21 +82,3 @@
     }
   }
-
-  internal class DebugWriter : TextWriter {
-    public override Encoding Encoding {
-      get { return Encoding.UTF8; }
-    }
-
-    public override void Write(char value) {
-      Debug.Write(value);
-    }
-
-    public override void Write(string value) {
-      Debug.Write(value);
-    }
-
-    public override void WriteLine(string value) {
-      Debug.WriteLine(value);
-    }
-  }
 }
Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 9433)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 9434)
@@ -39,10 +39,10 @@
   [HiveOperationContextBehavior]
   public class HiveService : IHiveService {
-    private IHiveDtoDao dtoDao {
-      get { return ServiceLocator.Instance.HiveDtoDao; }
-    }
     private IHiveDao dao {
       get { return ServiceLocator.Instance.HiveDao; }
     }
+    private IOptimizedHiveDao optimizedDao {
+      get { return ServiceLocator.Instance.OptimizedHiveDao; }
+    }
     private Access.IRoleVerifier authen {
       get { return ServiceLocator.Instance.RoleVerifier; }
@@ -68,11 +68,17 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        task.Id = dtoDao.AddTask(task);
-        taskData.TaskId = task.Id;
-        taskData.LastUpdate = DateTime.Now;
-        dtoDao.AssignJobToResource(task.Id, resourceIds);
-        dtoDao.AddTaskData(taskData);
-        dtoDao.UpdateTaskState(task.Id, DA.TaskState.Waiting, null, userManager.CurrentUserId, null);
-        return taskData.TaskId;
+        var t = DT.Convert.ToEntity(task);
+        t.RequiredPlugins.AddRange(task.PluginsNeededIds.Select(pluginId => new DA.RequiredPlugin { Task = t, PluginId = pluginId }));
+
+        t.JobData = DT.Convert.ToEntity(taskData);
+        t.JobData.LastUpdate = DateTime.Now;
+
+        optimizedDao.AddTask(t);
+
+        dao.AssignJobToResource(t.TaskId, resourceIds);
+
+        optimizedDao.UpdateTaskState(t.TaskId, DA.TaskState.Waiting, null, userManager.CurrentUserId, null);
+
+        return t.TaskId;
       }, false, true);
     }
@@ -80,8 +86,6 @@
     public Guid AddChildTask(Guid parentTaskId, Task task, TaskData taskData) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      return trans.UseTransaction(() => {
-        task.ParentTaskId = parentTaskId;
-        return AddTask(task, taskData, dtoDao.GetAssignedResources(parentTaskId).Select(x => x.Id));
-      }, false, true);
+      task.ParentTaskId = parentTaskId;
+      return AddTask(task, taskData, optimizedDao.GetAssignedResourceIds(parentTaskId));
     }
 
@@ -91,5 +95,5 @@
 
       return trans.UseTransaction(() => {
-        return DT.Convert.ToDto(dao.GetTaskById(taskId));
+        return DT.Convert.ToDto(optimizedDao.GetTaskById(taskId));
       }, false, false);
     }
@@ -98,5 +102,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        var tasks = dtoDao.GetTasks(x => true);
+        var tasks = dao.GetTasks(x => true);
         foreach (var task in tasks)
           author.AuthorizeForTask(task.Id, Permission.Read);
@@ -109,5 +113,5 @@
 
       return trans.UseTransaction(() => {
-        var tasks = dtoDao.GetTasks(x => taskIds.Contains(x.TaskId)).Select(x => new LightweightTask(x)).ToArray();
+        var tasks = dao.GetTasks(x => taskIds.Contains(x.TaskId)).Select(x => new LightweightTask(x)).ToArray();
         foreach (var task in tasks)
           author.AuthorizeForTask(task.Id, Permission.Read);
@@ -132,5 +136,5 @@
 
       return trans.UseTransaction(() => {
-        return dao.GetLightweightTasks(jobId).ToArray();
+        return optimizedDao.GetLightweightTasks(jobId).ToArray();
       }, false, true);
     }
@@ -141,5 +145,5 @@
 
       return trans.UseTransaction(() => {
-        return dtoDao.GetLightweightTasksWithoutStateLog(task => task.JobId == jobId).ToArray();
+        return dao.GetLightweightTasksWithoutStateLog(task => task.JobId == jobId).ToArray();
       }, false, false);
     }
@@ -150,5 +154,5 @@
 
       return trans.UseTransaction(() => {
-        return dtoDao.GetTaskData(taskId);
+        return dao.GetTaskData(taskId);
       });
     }
@@ -159,6 +163,6 @@
 
       trans.UseTransaction(() => {
-        var task = dao.GetTaskByDto(taskDto);
-        dao.UpdateTask(task);
+        var task = optimizedDao.GetTaskByDto(taskDto);
+        optimizedDao.UpdateTask(task);
       });
     }
@@ -169,12 +173,12 @@
 
       trans.UseTransaction(() => {
-        var t = dao.GetTaskByDto(task);
-        dao.UpdateTask(t);
-      });
-
-      trans.UseTransaction(() => {
-        var data = dao.GetTaskDataByDto(taskData);
+        var t = optimizedDao.GetTaskByDto(task);
+        optimizedDao.UpdateTask(t);
+      });
+
+      trans.UseTransaction(() => {
+        var data = optimizedDao.GetTaskDataByDto(taskData);
         data.LastUpdate = DateTime.Now;
-        dao.UpdateTaskData(data);
+        optimizedDao.UpdateTaskData(data);
       });
     }
@@ -184,5 +188,5 @@
       author.AuthorizeForTask(taskId, Permission.Full);
       trans.UseTransaction(() => {
-        dtoDao.DeleteTask(taskId);
+        dao.DeleteTask(taskId);
       });
     }
@@ -194,6 +198,6 @@
         var tasks = GetChildTasks(parentTaskId, true, false);
         foreach (var task in tasks) {
-          dtoDao.DeleteTask(task.Id);
-          dtoDao.DeleteTaskData(task.Id);
+          dao.DeleteTask(task.Id);
+          dao.DeleteTaskData(task.Id);
         };
       });
@@ -205,5 +209,5 @@
 
       return trans.UseTransaction(() => {
-        var task = dao.UpdateTaskState(taskId, DT.Convert.ToEntity(taskState), slaveId, userId, exception);
+        var task = optimizedDao.UpdateTaskState(taskId, DT.Convert.ToEntity(taskState), slaveId, userId, exception);
 
         if (task.Command.HasValue && task.Command.Value == DA.Command.Pause && task.State == DA.TaskState.Paused) {
@@ -215,8 +219,8 @@
         } else if (taskState == TaskState.Paused && !task.Command.HasValue) {
           // slave paused and uploaded the task (no user-command) -> set waiting.
-          task = dao.UpdateTaskState(taskId, DA.TaskState.Waiting, slaveId, userId, exception);
-        }
-
-        //dao.UpdateTaskAndPlugins(task); no idea why this is needed
+          task = optimizedDao.UpdateTaskState(taskId, DA.TaskState.Waiting, slaveId, userId, exception);
+        }
+
+        //optimizedDao.UpdateTaskAndPlugins(task); no idea why this is needed
         return DT.Convert.ToDto(task);
       });
@@ -225,5 +229,5 @@
     public IEnumerable<Task> GetTasksByResourceId(Guid resourceId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
-      var tasks = trans.UseTransaction(() => dtoDao.GetJobsByResourceId(resourceId));
+      var tasks = trans.UseTransaction(() => dao.GetJobsByResourceId(resourceId));
       foreach (var task in tasks)
         author.AuthorizeForTask(task.Id, Permission.Read);
@@ -237,8 +241,8 @@
       author.AuthorizeForTask(taskId, Permission.Full);
       trans.UseTransaction(() => {
-        var task = dtoDao.GetTask(taskId);
+        var task = dao.GetTask(taskId);
         if (task.State == TaskState.Calculating || task.State == TaskState.Transferring) {
           task.Command = Command.Stop;
-          dtoDao.UpdateTask(task);
+          dao.UpdateTask(task);
         } else {
           if (task.State != TaskState.Aborted && task.State != TaskState.Finished && task.State != TaskState.Failed) {
@@ -253,8 +257,8 @@
       author.AuthorizeForTask(taskId, Permission.Full);
       trans.UseTransaction(() => {
-        var job = dtoDao.GetTask(taskId);
+        var job = dao.GetTask(taskId);
         if (job.State == TaskState.Calculating || job.State == TaskState.Transferring) {
           job.Command = Command.Pause;
-          dtoDao.UpdateTask(job);
+          dao.UpdateTask(job);
         } else {
           job = UpdateTaskState(taskId, TaskState.Paused, null, null, string.Empty);
@@ -267,7 +271,7 @@
       author.AuthorizeForTask(taskId, Permission.Full);
       trans.UseTransaction(() => {
-        Task task = dtoDao.UpdateTaskState(taskId, DA.TaskState.Waiting, null, userManager.CurrentUserId, string.Empty);
+        Task task = dao.UpdateTaskState(taskId, DA.TaskState.Waiting, null, userManager.CurrentUserId, string.Empty);
         task.Command = null;
-        dtoDao.UpdateTask(task);
+        dao.UpdateTask(task);
       });
     }
@@ -279,10 +283,10 @@
       author.AuthorizeForJob(id, Permission.Read);
       return trans.UseTransaction(() => {
-        var job = dtoDao.GetJobs(x =>
+        var job = dao.GetJobs(x =>
               x.JobId == id
               && (x.OwnerUserId == userManager.CurrentUserId || x.JobPermissions.Count(hep => hep.Permission != DA.Permission.NotAllowed && hep.GrantedUserId == userManager.CurrentUserId) > 0)
             ).FirstOrDefault();
         if (job != null) {
-          job.Permission = DT.Convert.ToDto(dtoDao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
+          job.Permission = DT.Convert.ToDto(dao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
           job.OwnerUsername = userManager.GetUserById(job.OwnerUserId).UserName;
         }
@@ -294,8 +298,8 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        var jobs = dtoDao.GetJobs(x => x.OwnerUserId == userManager.CurrentUserId || x.JobPermissions.Count(hep => hep.Permission != DA.Permission.NotAllowed && hep.GrantedUserId == userManager.CurrentUserId) > 0);
+        var jobs = dao.GetJobs(x => x.OwnerUserId == userManager.CurrentUserId || x.JobPermissions.Count(hep => hep.Permission != DA.Permission.NotAllowed && hep.GrantedUserId == userManager.CurrentUserId) > 0);
         foreach (var job in jobs) {
           author.AuthorizeForJob(job.Id, Permission.Read);
-          job.Permission = DT.Convert.ToDto(dtoDao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
+          job.Permission = DT.Convert.ToDto(dao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
           job.OwnerUsername = userManager.GetUserById(job.OwnerUserId).UserName;
         }
@@ -307,7 +311,7 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       return trans.UseTransaction(() => {
-        var jobs = dtoDao.GetJobs(x => true);
+        var jobs = dao.GetJobs(x => true);
         foreach (var job in jobs) { // no authorization here, since this method is admin-only! (admin is allowed to read all task)
-          job.Permission = DT.Convert.ToDto(dtoDao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
+          job.Permission = DT.Convert.ToDto(dao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
           job.OwnerUsername = userManager.GetUserById(job.OwnerUserId).UserName;
         }
@@ -321,5 +325,5 @@
         jobDto.OwnerUserId = userManager.CurrentUserId;
         jobDto.DateCreated = DateTime.Now;
-        return dtoDao.AddJob(jobDto);
+        return dao.AddJob(jobDto);
       });
     }
@@ -329,5 +333,5 @@
       author.AuthorizeForJob(jobDto.Id, Permission.Full);
       trans.UseTransaction(() => {
-        dtoDao.UpdateJob(jobDto);
+        dao.UpdateJob(jobDto);
       });
     }
@@ -337,5 +341,5 @@
       author.AuthorizeForJob(jobId, Permission.Full);
       trans.UseTransaction(() => {
-        dtoDao.DeleteJob(jobId); // child task will be deleted by db-trigger
+        dao.DeleteJob(jobId); // child task will be deleted by db-trigger
       });
     }
@@ -346,9 +350,9 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       trans.UseTransaction(() => {
-        Job job = dtoDao.GetJob(jobId);
+        Job job = dao.GetJob(jobId);
         if (job == null) throw new FaultException<FaultReason>(new FaultReason("Could not find task with id " + jobId));
-        Permission perm = DT.Convert.ToDto(dtoDao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
+        Permission perm = DT.Convert.ToDto(dao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
         if (perm != Permission.Full) throw new FaultException<FaultReason>(new FaultReason("Not allowed to grant permissions for this experiment"));
-        dtoDao.SetJobPermission(jobId, userManager.CurrentUserId, grantedUserId, DT.Convert.ToEntity(permission));
+        dao.SetJobPermission(jobId, userManager.CurrentUserId, grantedUserId, DT.Convert.ToEntity(permission));
       });
     }
@@ -357,9 +361,9 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       trans.UseTransaction(() => {
-        Job job = dtoDao.GetJob(jobId);
+        Job job = dao.GetJob(jobId);
         if (job == null) throw new FaultException<FaultReason>(new FaultReason("Could not find task with id " + jobId));
-        DA.Permission perm = dtoDao.GetPermissionForJob(job.Id, userManager.CurrentUserId);
+        DA.Permission perm = dao.GetPermissionForJob(job.Id, userManager.CurrentUserId);
         if (perm != DA.Permission.Full) throw new FaultException<FaultReason>(new FaultReason("Not allowed to grant permissions for this experiment"));
-        dtoDao.SetJobPermission(jobId, userManager.CurrentUserId, grantedUserId, DA.Permission.NotAllowed);
+        dao.SetJobPermission(jobId, userManager.CurrentUserId, grantedUserId, DA.Permission.NotAllowed);
       });
     }
@@ -368,7 +372,7 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        DA.Permission currentUserPermission = dtoDao.GetPermissionForJob(jobId, userManager.CurrentUserId);
+        DA.Permission currentUserPermission = dao.GetPermissionForJob(jobId, userManager.CurrentUserId);
         if (currentUserPermission != DA.Permission.Full) throw new FaultException<FaultReason>(new FaultReason("Not allowed to list permissions for this experiment"));
-        return dtoDao.GetJobPermissions(x => x.JobId == jobId);
+        return dao.GetJobPermissions(x => x.JobId == jobId);
       });
     }
@@ -387,12 +391,12 @@
 
       trans.UseTransaction(() => {
-        var slave = dtoDao.GetSlave(slaveInfo.Id);
+        var slave = dao.GetSlave(slaveInfo.Id);
 
         if (slave == null) {
-          var healGroup = dtoDao.GetResources(x => x.Name == "HEAL").First();
+          var healGroup = dao.GetResources(x => x.Name == "HEAL").First();
           if (healGroup != null) {
             slaveInfo.ParentResourceId = healGroup.Id;
           }
-          dtoDao.AddSlave(slaveInfo);
+          dao.AddSlave(slaveInfo);
         } else {
           slave.Name = slaveInfo.Name;
@@ -413,5 +417,5 @@
           // don't update those properties: dbSlave.IsAllowedToCalculate, dbSlave.ParentResourceId 
 
-          dtoDao.UpdateSlave(slave);
+          dao.UpdateSlave(slave);
         }
       });
@@ -421,8 +425,8 @@
       authen.AuthenticateForAnyRole(HiveRoles.Slave);
       trans.UseTransaction(() => {
-        var slave = dtoDao.GetSlave(slaveId);
+        var slave = dao.GetSlave(slaveId);
         if (slave != null) {
           slave.SlaveState = SlaveState.Offline;
-          dtoDao.UpdateSlave(slave);
+          dao.UpdateSlave(slave);
         }
       });
@@ -457,5 +461,5 @@
         plugin.DateCreated = DateTime.Now;
 
-        var existing = dtoDao.GetPlugins(x => x.Hash != null).Where(x => x.Hash.SequenceEqual(plugin.Hash));
+        var existing = dao.GetPlugins(x => x.Hash != null).Where(x => x.Hash.SequenceEqual(plugin.Hash));
         if (existing.Count() > 0) {
           // a plugin already exists.
@@ -463,8 +467,8 @@
         }
 
-        Guid pluginId = dtoDao.AddPlugin(plugin);
+        Guid pluginId = dao.AddPlugin(plugin);
         foreach (PluginData pluginData in pluginDatas) {
           pluginData.PluginId = pluginId;
-          dtoDao.AddPluginData(pluginData);
+          dao.AddPluginData(pluginData);
         }
         return pluginId;
@@ -475,5 +479,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       return trans.UseTransaction(() => {
-        return DT.Convert.ToDto(dao.GetPluginById(pluginId));
+        return DT.Convert.ToDto(optimizedDao.GetPluginById(pluginId));
       });
     }
@@ -482,5 +486,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       return trans.UseTransaction(() => {
-        return dtoDao.GetPlugins(x => x.Hash == hash).FirstOrDefault();
+        return dao.GetPlugins(x => x.Hash == hash).FirstOrDefault();
       });
     }
@@ -491,5 +495,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       return trans.UseTransaction(() => {
-        return dtoDao.GetPlugins(x => x.Hash != null);
+        return dao.GetPlugins(x => x.Hash != null);
       });
     }
@@ -500,5 +504,5 @@
       return trans.UseTransaction(() => {
         foreach (Guid guid in pluginIds) {
-          pluginDatas.AddRange(dtoDao.GetPluginDatas(x => x.PluginId == guid).ToList());
+          pluginDatas.AddRange(dao.GetPluginDatas(x => x.PluginId == guid).ToList());
         }
         return pluginDatas;
@@ -509,5 +513,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       trans.UseTransaction(() => {
-        dtoDao.DeletePlugin(pluginId);
+        dao.DeletePlugin(pluginId);
       });
     }
@@ -518,9 +522,9 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       trans.UseTransaction(() => {
-        Resource resource = dtoDao.GetResource(resourceId);
+        Resource resource = dao.GetResource(resourceId);
         if (resource == null) throw new FaultException<FaultReason>(new FaultReason("Could not find resource with id " + resourceId));
         if (resource.OwnerUserId != userManager.CurrentUserId && !authen.IsInRole(HiveRoles.Administrator)) throw new FaultException<FaultReason>(new FaultReason("Not allowed to grant permission for this resource"));
         foreach (Guid id in grantedUserIds)
-          dtoDao.AddResourcePermission(new ResourcePermission { ResourceId = resourceId, GrantedByUserId = userManager.CurrentUserId, GrantedUserId = id });
+          dao.AddResourcePermission(new ResourcePermission { ResourceId = resourceId, GrantedByUserId = userManager.CurrentUserId, GrantedUserId = id });
       });
     }
@@ -529,9 +533,9 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       trans.UseTransaction(() => {
-        Resource resource = dtoDao.GetResource(resourceId);
+        Resource resource = dao.GetResource(resourceId);
         if (resource == null) throw new FaultException<FaultReason>(new FaultReason("Could not find resource with id " + resourceId));
         if (resource.OwnerUserId != userManager.CurrentUserId && !authen.IsInRole(HiveRoles.Administrator)) throw new FaultException<FaultReason>(new FaultReason("Not allowed to revoke permission for this resource"));
         foreach (Guid id in grantedUserIds)
-          dtoDao.DeleteResourcePermission(resourceId, id);
+          dao.DeleteResourcePermission(resourceId, id);
       });
     }
@@ -540,7 +544,7 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        Resource resource = dtoDao.GetResource(resourceId);
+        Resource resource = dao.GetResource(resourceId);
         if (resource == null) throw new FaultException<FaultReason>(new FaultReason("Could not find resource with id " + resourceId));
-        return dtoDao.GetResourcePermissions(x => x.ResourceId == resourceId);
+        return dao.GetResourcePermissions(x => x.ResourceId == resourceId);
       });
     }
@@ -549,5 +553,5 @@
     #region Resource Methods
     public IEnumerable<Resource> GetChildResources(Guid resourceId) {
-      return trans.UseTransaction(() => { return dtoDao.GetChildResources(resourceId); });
+      return trans.UseTransaction(() => { return dao.GetChildResources(resourceId); });
     }
     #endregion
@@ -557,5 +561,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Slave);
 
-      Slave s = trans.UseTransaction(() => { return dtoDao.GetSlave(slaveId); });
+      Slave s = trans.UseTransaction(() => { return dao.GetSlave(slaveId); });
       if (s != null) {
         return s.HbInterval;
@@ -567,20 +571,20 @@
     public Guid AddSlave(Slave slave) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
-      return trans.UseTransaction(() => dtoDao.AddSlave(slave));
+      return trans.UseTransaction(() => dao.AddSlave(slave));
     }
 
     public Guid AddSlaveGroup(SlaveGroup slaveGroup) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      return trans.UseTransaction(() => dtoDao.AddSlaveGroup(slaveGroup));
+      return trans.UseTransaction(() => dao.AddSlaveGroup(slaveGroup));
     }
 
     public Slave GetSlave(Guid slaveId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
-      return trans.UseTransaction(() => { return dtoDao.GetSlave(slaveId); });
+      return trans.UseTransaction(() => { return dao.GetSlave(slaveId); });
     }
 
     public SlaveGroup GetSlaveGroup(Guid slaveGroupId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
-      return trans.UseTransaction(() => { return dtoDao.GetSlaveGroup(slaveGroupId); });
+      return trans.UseTransaction(() => { return dao.GetSlaveGroup(slaveGroupId); });
     }
 
@@ -588,5 +592,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        return dtoDao.GetSlaves(x => true).Where(x => x.OwnerUserId == null
+        return dao.GetSlaves(x => true).Where(x => x.OwnerUserId == null
                                            || x.OwnerUserId == userManager.CurrentUserId
                                            || userManager.VerifyUser(userManager.CurrentUserId, GetResourcePermissions(x.Id).Select(y => y.GrantedUserId).ToList())
@@ -598,5 +602,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        return dtoDao.GetSlaveGroups(x => true).Where(x => x.OwnerUserId == null
+        return dao.GetSlaveGroups(x => true).Where(x => x.OwnerUserId == null
                                                 || x.OwnerUserId == userManager.CurrentUserId
                                                 || userManager.VerifyUser(userManager.CurrentUserId, GetResourcePermissions(x.Id).Select(y => y.GrantedUserId).ToList())
@@ -608,5 +612,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       trans.UseTransaction(() => {
-        dtoDao.UpdateSlave(slave);
+        dao.UpdateSlave(slave);
       });
     }
@@ -615,5 +619,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       trans.UseTransaction(() => {
-        dtoDao.UpdateSlaveGroup(slaveGroup);
+        dao.UpdateSlaveGroup(slaveGroup);
       });
     }
@@ -623,5 +627,5 @@
       author.AuthorizeForResourceAdministration(slaveId);
       trans.UseTransaction(() => {
-        dtoDao.DeleteSlave(slaveId);
+        dao.DeleteSlave(slaveId);
       });
     }
@@ -631,5 +635,5 @@
       author.AuthorizeForResourceAdministration(slaveGroupId);
       trans.UseTransaction(() => {
-        dtoDao.DeleteSlaveGroup(slaveGroupId);
+        dao.DeleteSlaveGroup(slaveGroupId);
       });
     }
@@ -638,7 +642,7 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       trans.UseTransaction(() => {
-        var resource = dtoDao.GetResource(resourceId);
+        var resource = dao.GetResource(resourceId);
         resource.ParentResourceId = slaveGroupId;
-        dtoDao.UpdateResource(resource);
+        dao.UpdateResource(resource);
       });
     }
@@ -647,7 +651,7 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       trans.UseTransaction(() => {
-        var resource = dtoDao.GetResource(resourceId);
+        var resource = dao.GetResource(resourceId);
         resource.ParentResourceId = null;
-        dtoDao.UpdateResource(resource);
+        dao.UpdateResource(resource);
       });
     }
@@ -656,5 +660,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        var resource = dtoDao.GetResources(x => x.Name == resourceName).FirstOrDefault();
+        var resource = dao.GetResources(x => x.Name == resourceName).FirstOrDefault();
         if (resource != null) {
           return resource.Id;
@@ -670,7 +674,7 @@
       bool cleanup = false;
       trans.UseTransaction(() => {
-        DateTime lastCleanup = dtoDao.GetLastCleanup();
+        DateTime lastCleanup = dao.GetLastCleanup();
         if (force || DateTime.Now - lastCleanup > HeuristicLab.Services.Hive.Properties.Settings.Default.CleanupInterval) {
-          dtoDao.SetLastCleanup(DateTime.Now);
+          dao.SetLastCleanup(DateTime.Now);
           cleanup = true;
         }
@@ -687,5 +691,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       author.AuthorizeForResourceAdministration(downtime.ResourceId);
-      return trans.UseTransaction(() => dtoDao.AddDowntime(downtime));
+      return trans.UseTransaction(() => dao.AddDowntime(downtime));
     }
 
@@ -695,5 +699,5 @@
       // author.AuthorizeForResource(resourceId);
       trans.UseTransaction(() => {
-        dtoDao.DeleteDowntime(downtimeId);
+        dao.DeleteDowntime(downtimeId);
       });
     }
@@ -703,5 +707,5 @@
       author.AuthorizeForResourceAdministration(downtime.ResourceId);
       trans.UseTransaction(() => {
-        dtoDao.UpdateDowntime(downtime);
+        dao.UpdateDowntime(downtime);
       });
     }
@@ -709,5 +713,5 @@
     public IEnumerable<Downtime> GetDowntimesForResource(Guid resourceId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      return trans.UseTransaction(() => dtoDao.GetDowntimes(x => x.ResourceId == resourceId));
+      return trans.UseTransaction(() => dao.GetDowntimes(x => x.ResourceId == resourceId));
     }
     #endregion
@@ -732,5 +736,5 @@
     #region UserPriority Methods
     public IEnumerable<UserPriority> GetUserPriorities() {
-      return trans.UseTransaction(() => dtoDao.GetUserPriorities(x => true));
+      return trans.UseTransaction(() => dao.GetUserPriorities(x => true));
     }
     #endregion
@@ -738,5 +742,5 @@
     #region Helper Methods
     private IEnumerable<Task> GetChildTasks(Guid? parentTaskId, bool recursive, bool includeParent) {
-      var tasks = new List<Task>(dtoDao.GetTasks(x => parentTaskId == null ? !x.ParentTaskId.HasValue : x.ParentTaskId.Value == parentTaskId));
+      var tasks = new List<Task>(dao.GetTasks(x => parentTaskId == null ? !x.ParentTaskId.HasValue : x.ParentTaskId.Value == parentTaskId));
 
       if (recursive) {
@@ -755,8 +759,8 @@
     #region Statistics Methods
     public IEnumerable<Statistics> GetStatistics() {
-      return trans.UseTransaction(() => { return dtoDao.GetStatistics(x => true); });
+      return trans.UseTransaction(() => { return dao.GetStatistics(x => true); });
     }
     public IEnumerable<Statistics> GetStatisticsForTimePeriod(DateTime from, DateTime to) {
-      return trans.UseTransaction(() => { return dtoDao.GetStatistics(x => x.Timestamp >= from && x.Timestamp <= to); });
+      return trans.UseTransaction(() => { return dao.GetStatistics(x => x.Timestamp >= from && x.Timestamp <= to); });
     }
     #endregion
